#ifndef ENVOY_ENVOY_H
#define ENVOY_ENVOY_H
/*------------------------------------------------------------------------*/
/*                                                                        *
 *      $Id: envoy.h,v 1.10 1998/06/11 15:01:50 heinz Exp $
 *
 *      Tags for the envoy.library.
 *                                                                        */
/*------------------------------------------------------------------------*/

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif /* UTILITY_TAGITEM_H */

#ifndef ENVOY_NIPC_H
#include <envoy/nipc.h>
#endif /* ENVOY_NIPC_H */

/*------------------------------------------------------------------------*/
/* Host request tags */
#define HREQ_Dummy          (TAG_USER + 0xB1300)
#define HREQ_Buffer         (HREQ_Dummy + 1)
#define HREQ_BuffSize       (HREQ_Dummy + 2)
#define HREQ_Left           (HREQ_Dummy + 3)    /* OBSOLETE, DON'T USE */
#define HREQ_Top            (HREQ_Dummy + 4)    /* OBSOLETE, DON'T USE */
#define HREQ_Width          (HREQ_Dummy + 5)    /* OBSOLETE, DON'T USE */
#define HREQ_Height         (HREQ_Dummy + 6)    /* OBSOLETE, DON'T USE */
#define HREQ_DefaultRealm   (HREQ_Dummy + 7)
#define HREQ_NoRealms       (HREQ_Dummy + 8)
#define HREQ_Screen         (HREQ_Dummy + 9)
#define HREQ_Title          (HREQ_Dummy + 10)
#define HREQ_NoResizer      (HREQ_Dummy + 11)   /* OBSOLETE, DON'T USE */
#define HREQ_NoDragBar      (HREQ_Dummy + 12)   /* OBSOLETE, DON'T USE */
#define HREQ_Window         (HREQ_Dummy + 13)
#define HREQ_OptimWindow    (HREQ_Dummy + 14)
#define HREQ_CallBack       (LREQ_Dummy + 15)
#define HREQ_MsgPort        (LREQ_Dummy + 16)

/*------------------------------------------------------------------------*/
/* Login request tags */
#define LREQ_Dummy          (TAG_USER + 0xB1400)
#define LREQ_NameBuff       (LREQ_Dummy + 1)
#define LREQ_NameBuffLen    (LREQ_Dummy + 2)
#define LREQ_PassBuff       (LREQ_Dummy + 3)
#define LREQ_PassBuffLen    (LREQ_Dummy + 4)
#define LREQ_Left           (LREQ_Dummy + 5)    /* OBSOLETE, DON'T USE */
#define LREQ_Top            (LREQ_Dummy + 6)    /* OBSOLETE, DON'T USE */
#define LREQ_Width          (LREQ_Dummy + 7)    /* OBSOLETE, DON'T USE */
#define LREQ_Height         (LREQ_Dummy + 8)    /* OBSOLETE, DON'T USE */
#define LREQ_Screen         (LREQ_Dummy + 9)
#define LREQ_Title          (LREQ_Dummy + 10)
#define LREQ_NoDragBar      (LREQ_Dummy + 11)   /* OBSOLETE, DON'T USE */
#define LREQ_Window         (LREQ_Dummy + 12)
#define LREQ_CallBack       (LREQ_Dummy + 13)
#define LREQ_MsgPort        (LREQ_Dummy + 14)
#define LREQ_NoSizeGadget   (LREQ_Dummy + 15)   /* OBSOLETE, DON'T USE */
#define LREQ_OptimWindow    (LREQ_Dummy + 16)
#define LREQ_UserName       (LREQ_Dummy + 17)
#define LREQ_Password       (LREQ_Dummy + 18)

/*------------------------------------------------------------------------*/
/* User/group request tags */
#define UGREQ_Dummy         (TAG_USER + 0xB1400)
#define UGREQ_UserBuff      (UGREQ_Dummy + 1)
#define UGREQ_UserBuffLen   (UGREQ_Dummy + 2)
#define UGREQ_GroupBuff     (UGREQ_Dummy + 3)
#define UGREQ_GroupBuffLen  (UGREQ_Dummy + 4)
#define UGREQ_Left          (UGREQ_Dummy + 5)    /* OBSOLETE, DON'T USE */
#define UGREQ_Top           (UGREQ_Dummy + 6)    /* OBSOLETE, DON'T USE */
#define UGREQ_Width         (UGREQ_Dummy + 7)    /* OBSOLETE, DON'T USE */
#define UGREQ_Height        (UGREQ_Dummy + 8)    /* OBSOLETE, DON'T USE */
#define UGREQ_Screen        (UGREQ_Dummy + 9)
#define UGREQ_Title         (UGREQ_Dummy + 10)
#define UGREQ_NoDragBar     (UGREQ_Dummy + 11)   /* OBSOLETE, DON'T USE */
#define UGREQ_Window        (UGREQ_Dummy + 12)
#define UGREQ_CallBack      (UGREQ_Dummy + 13)
#define UGREQ_MsgPort       (UGREQ_Dummy + 14)
#define UGREQ_NoSizeGadget  (UGREQ_Dummy + 15)   /* OBSOLETE, DON'T USE */
#define UGREQ_UserList      (UGREQ_Dummy + 16)
#define UGREQ_GroupList     (UGREQ_Dummy + 17)
#define UGREQ_OptimWindow   (UGREQ_Dummy + 18)

/*------------------------------------------------------------------------*/
/* Password request tags */
#define PWREQ_Dummy         (TAG_USER + 0xB1400)
#define PWREQ_OldPassword   (PWREQ_Dummy + 1)   /* Option old PW to verify */
#define PWREQ_NewPWBuff     (PWREQ_Dummy + 2)   /* Memory for the new PW */
#define PWREQ_NewPWBuffLen  (PWREQ_Dummy + 3)
#define PWREQ_PWRequired    (PWREQ_Dummy + 4)   /* new PW may not be empty */
#define PWREQ_Screen        (PWREQ_Dummy + 9)
#define PWREQ_Title         (PWREQ_Dummy + 10)
#define PWREQ_Window        (PWREQ_Dummy + 12)
#define PWREQ_CallBack      (PWREQ_Dummy + 13)
#define PWREQ_MsgPort       (PWREQ_Dummy + 14)
#define PWREQ_OptimWindow   (PWREQ_Dummy + 18)
#define PWREQ_OldPWLen      (PWREQ_Dummy + 19)  /* Input old pw, don't verify */

/*------------------------------------------------------------------------*/

#endif /* ENVOY_ENVOY_H */

